Description

=begin

Hi,

I just ran into this and found that a 1.9 bug for this is open already. But this issue also applies to 1.8.7. So I'm duplicating the
description from here: http:/redmine.ruby-lang.org/issues/show/1559

In erb you're supposed to be able to do single line comments:
<% # this is a comment %>

However, this does not work in ruby 1.9.1.

Temporary work around is to put the '%>' on a newline:

<% # this comment works in 1.9.1
Yo>

Please see attached unit test.
=end

Related issues:
Has duplicate Ruby - Bug #14243: Comments inside ERB tags broken Closed

History

#1 - 08/04/2009 02:27 AM - bitsweat (Jeremy Daer)

=begin
This is not a bug. Use <# for erb comments.
=end

#2 - 04/06/2010 09:30 AM - rsalkeld (Robin Salkeld)
=begin
This seems to be caused by removing \n from the regular expressions used in ERB::Compiler::SimpleScanner2:

stag_reg = /(. ?)(<% %|<%=|<%#|<%[\z)/m
etag_reg = /(.?)(%%>|%>|\z)/m

It looks like the original change was intended as an optimization, but unintentionally changed the behaviour. Restoring the \n's fixes it.

<%# may work for comments as well, but a lot of us have relied on the old behaviour, and | see no reason not to fix an accidental regression.
=end

#3 - 04/06/2010 11:42 AM - bitsweat (Jeremy Daer)

=begin
One reason not to restore the bug: it would break in any other conformant eRuby implementation, like Erubis.
=end

#4 - 04/06/2010 12:18 PM - coatl (caleb clausen)

=begin
Aside from compatibility with other implementations, what is harmed by making the suggested change? Would it break something that currently
works? (I would expect that any legal ruby should be usable inside <%...%>, myself...)
=end

#5 - 11/25/2010 02:33 PM - shyouhei (Shyouhei Urabe)
- Status changed from Open to Assigned

- Assignee set to seki (Masatoshi Seki)

=begin

=end

#6 - 01/19/2015 01:43 PM - hsbt (Hiroshi SHIBATA)
- Project changed from 2 to Ruby
- Description updated

#7 - 05/16/2017 12:54 AM - kOkubun (Takashi Kokubun)
- Status changed from Assigned to Rejected

- Assignee changed from seki (Masatoshi Seki) to kOkubun (Takashi Kokubun)

Supporting this kind of behavior doesn't make sense to me. Suppose following erb template:

foo <% # commentl %> bar <% # comment2 %> baz

If such a feature is supported, | would expect this template to render "foo bar baz". But since " # comment1 " and " # comment2 " are embedded as
Ruby script, concatenation for " bar ", " baz " and "\n" will be regarded as comment. And it's inevitable because we should keep erb's line numbers in
generated code for correct backtrace.

In that situation, if we really want to support this, we need to trim comments when compiling erb by scanning all embedded Ruby scripts using Ripper
or something. | don't think it's a consistent behavior considering embedded scripts are originally evaluated only on rendering. And it will have
performance regression for compiling time. So the most reasonable way to achieve such single-line comment is just using "<%#".

As https://bugs.ruby-lang.org/issues/1559 is rejected and | think it's reasonable, we need to fix all "<% #" to "<%#". Sorry for your inconvenience by
regression.

#8 - 12/27/2017 10:35 AM - kOkubun (Takashi Kokubun)
- Has duplicate Bug #14243: Comments inside ERB tags broken added

Files

test_erb.rb 313 Bytes 08/03/2009 jfahrenkrug (Johannes Fahrenkrug)

06/13/2025 22


https://bugs.ruby-lang.org/issues/1559
http://www.tcpdf.org

